<template>
  <div class="flex items-center px-2">
    <span class="w-1 h-1 rounded-full bg-primary mr-1"></span>
    <p class="text-sm font-medium uppercase tc-5">{{ getTabName }}</p>
  </div>
  <div class="w-full concrete-games">
    <swiper
      :slides-per-view="1"
      :space-between="8"
      :centered-slides="true"
      :modules="[Pagination]"
      :pagination="paginationConfig"
      :initial-slide="0"
      class="!px-2"
      loop
    >
      <swiper-slide v-for="(items, index) in getEntryList" :key="index">
        <div
          class="grid gap-2"
          :class="[isShow3Columns ? 'grid-cols-3' : 'grid-cols-2']"
        >
          <SharedConcreteCard
            v-for="(game, childIndex) in items"
            :key="`game-${childIndex}`"
            :game="game"
            :count-by-provider="gamesCountByProvider"
            :card-style="isShow3Columns ? 'small' : 'large'"
            @click="onCardClicked"
          />
        </div>
      </swiper-slide>
    </swiper>
    <div
      class="game-pagination !relative flex items-center justify-center gap-1 !py-2 !bottom-auto !top-auto"
    ></div>
  </div>
</template>

<script setup lang="ts">
import { Pagination } from "swiper";
import SportDisplayModel from "~~/components/sport/sportDisplayModel";
import { GameProviders } from "~~/models/bsiGameList";
import textHelper from "~~/utils/formatHelpers/textFormatHelper";
import { handleGameEntryOpenWindow } from "@/composables/useTheme";
import { appNavigationStore } from "~~/store/app-navigation";
import EnumMutation from "~~/models/enums/enumMutation";

const route = useRoute();
const router = useRouter();

const { toggleLoginRegisterDialog } = commonHelper;
const { gameEntrySelected } = useGameEntryBaseOnTabSelected();
const { providers, authenticated } = useGameEntryComponent();

const paginationConfig = {
  el: ".game-pagination",
  clickable: true,
};

const isGamePage = computed(() => String(route.path).includes("/games"));

const isShow3Columns = computed(() => {
  const path = String(route.path);

  return ["/live-casino", "/games", "/lottery"].includes(path);
});

const getEntryList = computed(() => {
  let items: GameProviders[] | SportDisplayModel[] = [];
  if (isGamePage.value) {
    items = providers.value;
  } else {
    items = gameEntrySelected.value.map((game) => new SportDisplayModel(game));
  }

  const chunkSize = isShow3Columns.value ? 9 : 6;
  const chunks = [];
  for (let i = 0; i < items.length; i += chunkSize) {
    chunks.push(items.slice(i, i + chunkSize));
  }

  return chunks;
});

const gamesCountByProvider = computed(() =>
  textHelper.checkMultiple(gameEntrySelected.value)
);

const getTabName = computed(() => {
  const name = String(route.path)
    .toLowerCase()
    .replace("-", "_")
    .replace(/[-\s/]/g, "");
  return useI18n().t(name);
});

const onCardClicked = (game: GameProviders | SportDisplayModel) => {
  if (game instanceof GameProviders) {
    appNavigationStore.commit(
      EnumMutation.updateAppNavigationBackToRoute,
      "/games"
    );
    return router.replace(`/games/${game.ProviderName}`);
  }
  if (!authenticated.value) return toggleLoginRegisterDialog();
  handleGameEntryOpenWindow(game, 550, 850);
};
</script>

<style lang="scss">
.concrete-games {
  .swiper-slide {
    min-height: 316px;
  }
}
.game-pagination {
  .swiper-pagination-bullet {
    --swiper-pagination-bullet-horizontal-gap: 0;

    background-color: var(--text2);
    @apply mx-0 w-2 h-2 rounded transition-all duration-300;

    &.swiper-pagination-bullet-active {
      background-color: var(--primary);
      @apply w-6;
    }
  }
}
</style>
